<?php
// This file is part of CodeRunner - http://coderunner.org.nz/
//
// CodeRunner is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// CodeRunner is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with CodeRunner.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Example set-up config variables for running tests.
 *
 * DO NOT EDIT THIS FILE!
 *
 * To create your own test configuration, copy this file to
 * test-sandbox-config.php and edit that instead. In that file,
 * you only need to set configuration that is different from
 * the defaults below.
 *
 * These files are used by the setUp method in
 * qtype_coderunner_testcase.
 *
 * @package    qtype_coderunner
 * @copyright  2013 Richard Lobb, University of Canterbury
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

defined('MOODLE_INTERNAL') || die();

set_config('default_penalty_regime', '10, 20, ...', 'qtype_coderunner');
set_config('ideonesandbox_enabled', 0, 'qtype_coderunner');
set_config('jobesandbox_enabled', 0, 'qtype_coderunner');

// The next line is critical. If you're running Jobe on the same physical machine as
// Moodle, localhost is probably appropriate. For Docker, a value something like
// 172.17.0.1:4000 is probably required. If you have your own Jobe host elsewhere,
// specify it here.
set_config('jobe_host', 'localhost', 'qtype_coderunner');
set_config('jobe_apikey', '2AAA7A5415B4A9B394B54BF1D2E9D', 'qtype_coderunner');
set_config('ideone_user', 'coderunner', 'qtype_coderunner');
set_config('ideone_password', 'moodlequizzes', 'qtype_coderunner');

// Configuration extras, used only when testing.
set_config('jobe_apikey_enabled', 0, 'qtype_coderunner');
set_config('jobe_limits_enforced', 0, 'qtype_coderunner');
