/**
 * JavaScript for handling UI actions in the question authoring form.
 *
 * @module qtype_coderunner/authorform
 * @copyright  Richard Lobb, 2015, The University of Canterbury
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("qtype_coderunner/authorform",["jquery","qtype_coderunner/userinterfacewrapper","core/str"],(function($,ui,str){let currentQtype="";var JSON_TO_FORM_MAP={template:["#id_template","value",""],iscombinatortemplate:["#id_iscombinatortemplate","checked","",function(value){return"1"===value}],cputimelimitsecs:["#id_cputimelimitsecs","value",""],memlimitmb:["#id_memlimitmb","value",""],sandbox:["#id_sandbox","value","DEFAULT"],sandboxparams:["#id_sandboxparams","value",""],testsplitterre:["#id_testsplitterre","value","",function(splitter){return splitter.replace("\n","\\n")}],allowmultiplestdins:["#id_allowmultiplestdins","checked","",function(value){return"1"===value}],grader:["#id_grader","value","EqualityGrader"],resultcolumns:["#id_resultcolumns","value",""],language:["#id_language","value",""],acelang:["#id_acelang","value",""],uiplugin:["#id_uiplugin","value","ace"]};return{initEditForm:function(){var typeCombo=$("#id_coderunnertype"),prototypeDisplay=$("#id_isprototype"),template=$("#id_template"),evaluatePerStudent=$("#id_templateparamsevalpertry"),globalextra=$("#id_globalextra"),prototypeextra=$("#id_prototypeextra"),useace=$("#id_useace"),language=$("#id_language"),acelang=$("#id_acelang"),customise=$("#id_customise"),isCombinator=$("#id_iscombinatortemplate"),testSplitterRe=$("#id_testsplitterre"),allowMultipleStdins=$("#id_allowmultiplestdins"),customisationFieldSet=$("#id_customisationheader"),advancedCustomisation=$("#id_advancedcustomisationheader"),isCustomised=customise.prop("checked"),prototypeType=$("#id_prototypetype"),preloadHdr=$("#id_answerpreloadhdr"),courseId=$('input[name="courseid"]').prop("value"),questiontypeHelpDiv=$("#qtype-help"),precheck=$("select#id_precheck"),testtypedivs=$("div.testtype"),testsection=$("#id_testcasehdr"),brokenQuestion=$("#id_broken_question"),badQuestionLoad=$("#id_bad_question_load"),uiplugin=$("#id_uiplugin"),uiparameters=$("#id_uiparameters");function setUi(taId,uiname){var lang,uiWrapper,ta=$(document.getElementById(taId)),currentLang=ta.attr("data-lang"),paramsJson=ta.attr("data-params"),params={};ta.attr("data-prototypeextra",prototypeextra.val()),ta.attr("data-globalextra",globalextra.val()),ta.attr("data-test0",$("#id_testcode_0").val());try{params=JSON.parse(paramsJson)}catch(err){}"none"===(uiname=uiname.toLowerCase())&&(uiname=""),"id_templateparams"==taId||"id_uiparameters"==taId?lang="":(lang=language.prop("value"),"id_template"!==taId&&acelang.prop("value")&&(lang=function(acelang){var langs,i;if(acelang.indexOf(",")<0)return acelang;for(langs=acelang.split(","),i=0;i<langs.length;i++)if(langs[i].endsWith("*"))return langs[i].substr(0,langs[i].length-1);return langs.length>0?langs[0]:""}(acelang.prop("value")))),(uiWrapper=ta.data("current-ui-wrapper"))&&uiWrapper.uiname===uiname&&currentLang==lang||(ta.attr("data-lang",lang),uiWrapper?(params.lang=lang,uiWrapper.loadUi(uiname,params)):uiWrapper=new ui.InterfaceWrapper(uiname,taId))}function setUis(){let uiname=uiplugin.val(),answer=$("#id_answer"),enableUi=!0;if("html"===uiname&&""!==answer.attr("data-params"))try{!1===JSON.parse(answer.attr("data-params")).enable_in_editor&&(enableUi=!1)}catch(error){alert("Invalid UI parameters.")}enableUi&&(setUi("id_answer",uiname),setUi("id_answerpreload",uiname))}function setCustomisationVisibility(isVisible){var display=isVisible?"block":"none";customisationFieldSet.css("display",display),advancedCustomisation.css("display",display),isVisible&&useace.prop("checked")&&setUi("id_template","ace")}function copyFieldsFromQuestionType(newType,response){var formspecifier,attrval,isCombinatorEnabled;for(var key in function(stateOn){var uiWrapper,taIds=["id_template","id_uiparameters"];if(useace.prop("checked"))for(var i=0;i<taIds.length;i++)(uiWrapper=$(document.getElementById(taIds[i])).data("current-ui-wrapper"))&&stateOn?uiWrapper.restart():uiWrapper&&!stateOn&&uiWrapper.stop()}(!1),JSON_TO_FORM_MAP)formspecifier=JSON_TO_FORM_MAP[key],attrval=response[key]?response[key]:formspecifier[2],formspecifier.length>3&&(attrval=(0,formspecifier[3])(attrval)),$(formspecifier[0]).prop(formspecifier[1],attrval);customise.prop("checked",!1),str.get_string("coderunner_question_type","qtype_coderunner").then((function(s){var title,coderunner_descr,html,resultHtml;questiontypeHelpDiv.html((title=newType,coderunner_descr=s,html=response.questiontext,resultHtml='<p class="question-type-details-header">',resultHtml+=coderunner_descr,resultHtml+=title+"</p>\n"+html))})),setCustomisationVisibility(!1),isCombinatorEnabled=isCombinator.prop("checked"),testSplitterRe.prop("disabled",!isCombinatorEnabled),allowMultipleStdins.prop("disabled",!isCombinatorEnabled)}function langStringAlert(key,extra){window.hasOwnProperty("behattesting")&&window.behattesting||str.get_string(key,"qtype_coderunner").then((function(s){var message=s.replace(/\n/g," ");extra&&(message+="\n"+extra),alert(message)}))}function loadCustomisationFields(){let newType=typeCombo.children("option:selected").text();""!==newType&&"Undefined"!==newType&&(typeCombo.children("option:first-child").prop("disabled","disabled"),$.getJSON(M.cfg.wwwroot+"/question/type/coderunner/ajax.php",{qtype:newType,courseid:courseId,sesskey:M.cfg.sesskey},(function(outcome){if($("#id_qtype_coderunner_warning_div").empty(),outcome.success)copyFieldsFromQuestionType(newType,outcome),setUis(),loadUiParametersDescription(),currentQtype=newType,$("#id_qtype_coderunner_error_div").empty();else{const errorObject=function(questionType,error){const errorObject=JSON.parse(error);return str.get_string("prototype_error","qtype_coderunner").then((function(s){str.get_string(errorObject.alert,"qtype_coderunner",questionType).then((function(str){langStringAlert("prototype_load_failure",str);let errorMessage=s+"\n";errorMessage+=str+"\n",errorMessage+="CourseId: "+courseId+", qtype: "+questionType,template.prop("value",errorMessage)}))})),errorObject}(newType,outcome.error);currentQtype!==newType&&"duplicateprototype"===errorObject.error&&(!function(currentType,errorObject,newType){str.get_string("loadprototypeerror","qtype_coderunner",{oldtype:currentType,crtype:newType,outputstring:errorObject.extras}).then((function(str){$("#id_qtype_coderunner_warning_div").append($("<p>"+str+"</p>"))}))}(currentQtype,errorObject,newType),$("#id_coderunnertype").val(currentQtype))}})).fail((function(){langStringAlert("error_loading_prototype"),template.prop("value","*** AJAX ERROR. DON'T SAVE THIS! ***"),str.get_string("ajax_error","qtype_coderunner").then((function(s){template.prop("value",s)}))})))}function loadUiParametersDescription(){let newUi=uiplugin.children("option:selected").text();$.getJSON(M.cfg.wwwroot+"/question/type/coderunner/ajax.php",{uiplugin:newUi,courseid:courseId,sesskey:M.cfg.sesskey},(function(uiInfo){var table,currentuiparameters=uiparameters.val(),paramDescriptionDiv=$(".ui_parameters_descr"),showhidebutton=$('<button type="button" class="toggleuidetails">'+uiInfo.showdetails+"</button>");paramDescriptionDiv.empty(),paramDescriptionDiv.append(uiInfo.header),0==uiInfo.uiparamstable.length&&""===currentuiparameters.trim()?(uiparameters.val(""),$("#fgroup_id_uiparametergroup").hide()):(0!=uiInfo.uiparamstable.length&&(paramDescriptionDiv.append(showhidebutton),table=$(function(uiParamInfo){var param,i,html='<div class="uiparamtablediv"><table class="uiparamtable">\n',hdrs=uiParamInfo.columnheaders;for(html+="<tr><th>"+hdrs[0]+"</th><th>"+hdrs[1]+"</th><th>"+hdrs[2]+"</th></tr>\n",i=0;i<uiParamInfo.uiparamstable.length;i++)html+="<tr><td>"+(param=uiParamInfo.uiparamstable[i])[0]+"</td><td>"+param[1]+"</td><td>"+param[2]+"</td></tr>\n";return html+"</table></div>\n"}(uiInfo)),paramDescriptionDiv.append(table),table.hide(),showhidebutton.click((function(){showhidebutton.html()==uiInfo.showdetails?(table.show(),showhidebutton.html(uiInfo.hidedetails)):(table.hide(),showhidebutton.html(uiInfo.showdetails))}))),$("#fgroup_id_uiparametergroup").show(),useace.prop("checked")&&setUi("id_uiparameters","ace"))})).fail((function(){langStringAlert("error_loading_ui_descr")}))}function set_testtype_visibilities(){"3"===precheck.val()?testtypedivs.show():testtypedivs.hide()}function check_ace_lang(){"ace"===uiplugin.val()&&setUis()}0!=prototypeType.prop("value")&&(testsection.css("display","none"),prototypeDisplay.removeAttr("hidden"),1==prototypeType.prop("value")&&(str.get_string("proceed_at_own_risk","qtype_coderunner").then((function(s){alert(s)})),prototypeType.prop("disabled",!0),customise.prop("disabled",!0))),function(){let messagePara=null;""!==brokenQuestion.prop("value")&&(messagePara=$("<p>"+brokenQuestion.prop("value")+"</p>"),$("#id_qtype_coderunner_error_div").append(messagePara))}(),badQuestionLoad.prop("hidden"),currentQtype=typeCombo.children("option:selected").text(),setCustomisationVisibility(isCustomised),isCustomised?(setUis(),str.get_string("info_unavailable","qtype_coderunner").then((function(s){questiontypeHelpDiv.html("<p>"+s+"</p>")}))):loadCustomisationFields(),set_testtype_visibilities(),useace.prop("checked")&&(setUi("id_templateparams","ace"),setUi("id_uiparameters","ace")),loadUiParametersDescription(),customise.on("change",(function(){customise.prop("checked")?setCustomisationVisibility(!0):str.get_string("confirm_proceed","qtype_coderunner").then((function(s){window.confirm(s)?setCustomisationVisibility(!1):customise.prop("checked",!0)}))})),acelang.on("change",check_ace_lang),language.on("change",(function(){useace.prop("checked")&&setUi("id_template","ace"),check_ace_lang()})),typeCombo.on("change",(function(){customise.prop("checked")?str.get_string("question_type_changed","qtype_coderunner").then((function(s){window.confirm(s)&&loadCustomisationFields()})):loadCustomisationFields()})),useace.on("change",(function(){useace.prop("checked")?(setUi("id_template","ace"),setUi("id_templateparams","ace"),setUi("id_uiparameters","ace")):(setUi("id_template",""),setUi("id_templateparams",""),setUi("id_uiparameters",""))})),evaluatePerStudent.on("change",(function(){evaluatePerStudent.is(":checked")&&langStringAlert("templateparamsusingsandbox")})),uiplugin.on("change",(function(){setUis(),loadUiParametersDescription()})),precheck.on("change",set_testtype_visibilities),prototypeType.on("change",(function(){"0"==prototypeType.prop("value")?(testsection.css("display","block"),prototypeDisplay.attr("hidden","1")):(testsection.css("display","none"),prototypeDisplay.removeAttr("hidden"))})),new MutationObserver((function(){setUis()})).observe(preloadHdr.get(0),{attributes:!0}),$("button.replaceexpectedwithgot").click((function(){var gotPre=$(this).prev('pre[id^="id_got_"]'),testCaseId=gotPre.attr("id").replace("id_got_","");$("#id_expected_"+testCaseId).val(gotPre.text()),$("#id_fail_expected_"+testCaseId).html(gotPre.text()),$(".failrow_"+testCaseId).addClass("fixed"),$(this).prop("disabled",!0)})),$(".btn-primary").click((function(){typeCombo.prop("disabled",!1)}))}}}));

//# sourceMappingURL=authorform.min.js.map